## faac

faac — Free MPEG-2/4 AAC encoder

## Properties

gint | bitrate | Read / Write / Construct
gboolean | midside | Read / Write / Construct
GstFaacOutputFormat | outputformat | Read / Write
GstFaacProfile | profile | Read / Write
GstFaacShortCtl | shortctl | Read / Write / Construct
gboolean | tns | Read / Write / Construct
gint | quality | Read / Write / Construct
GstFaacBrtype | rate-control | Read / Write / Construct

## Types and Values

struct | GstFaac

## Implemented Interfaces

GstFaac implements GstPreset.

## Description

## Synopsis

### Element Information

plugin | faac
author | Ronald Bultje <rbultje@ronald.bitfreak.net>
class | Codec/Encoder/Audio

### Element Pads

name | sink
direction | sink
presence | always
details | audio/x-raw, format=(string)S16LE, layout=(string)interleaved, rate=(int){ 8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000, 64000, 88200, 96000 }, channels=(int)[ 1, 6 ]

name | src
direction | source
presence | always
details | audio/mpeg, mpegversion=(int)4, channels=(int)[ 1, 6 ], rate=(int){ 8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000, 64000, 88200, 96000 }, stream-format=(string){ adts, raw }, base-profile=(string){ main, lc, ssr, ltp }
| audio/mpeg, mpegversion=(int)2, channels=(int)[ 1, 6 ], rate=(int){ 8000, 11025, 12000, 16000, 22050, 24000, 32000, 44100, 48000, 64000, 88200, 96000 }, stream-format=(string){ adts, raw }, profile=(string){ main, lc }

## Functions

## Types and Values

### struct GstFaac

    struct GstFaac {
      GstAudioEncoder element;

      /* input format */
      gint format;
      /* input frame size */
      gint samples;
      /* required output buffer size */
      gint bytes;

      /* negotiated */
      gint mpegversion, outputformat;

      /* properties */
      gint bitrate,
           profile,
           quality,
           brtype,
           shortctl;
      gboolean tns,
               midside;

      /* FAAC object */
      faacEncHandle handle;
    };

## Property Details

### The `“bitrate”` property

      “bitrate”                  gint

Average Bitrate (ABR) in bits/sec.

Flags: Read / Write / Construct

Allowed values: [8000,320000]

Default value: 128000

### The `“midside”` property

      “midside”                  gboolean

Allow mid/side encoding.

Flags: Read / Write / Construct

Default value: TRUE

### The `“outputformat”` property

      “outputformat”             GstFaacOutputFormat

Format of output frames.

Flags: Read / Write

Default value: OUTPUTFORMAT_RAW

### The `“profile”` property

      “profile”                  GstFaacProfile

MPEG/AAC encoding profile.

Flags: Read / Write

Default value: LC

### The `“shortctl”` property

      “shortctl”                 GstFaacShortCtl

Block type encorcing.

Flags: Read / Write / Construct

Default value: SHORTCTL_NORMAL

### The `“tns”` property

      “tns”                      gboolean

Use temporal noise shaping.

Flags: Read / Write / Construct

Default value: FALSE

### The `“quality”` property

      “quality”                  gint

Variable bitrate (VBR) quantizer quality in %.

Flags: Read / Write / Construct

Allowed values: [1,1000]

Default value: 100

### The `“rate-control”` property

      “rate-control”             GstFaacBrtype

Encoding bitrate type (VBR/ABR).

Flags: Read / Write / Construct

Default value: VBR